
#property copyright "metaquote"
#property link      "http://www.metaquotes.net/"

#include <WinUser32.mqh>
#include <stdlib.mqh>

#import "MTFeedClient.dll"
   int mtFeed00(int a0);
   int mtFeed01(int a0, int& a1[], double& a2[], string& a3[]);
   void mtFeed02();
   void mtFeed03(int a0, int a1, int a2);
   void mtFeed04(int a0, int a1, int a2);
   void mtFeed05(int a0, int a1, double& a2[], int a3);
   void mtFeed06(int a0, int a1, double& a2[]);
   void mtFeed07(int a0);
   void mtFeed08(int a0, int a1, string a2);
   void mtFeed09(string a0, double a1, int a2);
   void mtFeed0A(int a0, int a1);
   void mtFeed0B(string a0);
   void mtFeed0C(int a0);
   void mtFeed0D(int a0);
   void mtFeed0E(int& a0[]);
#import

int gi_76 = 0;
int gia_80[];
int gia_84[][6];
string gsa_88[];
int gi_92 = WHOLE_ARRAY;
int gia_96[];
int gia_100[][5];
string gsa_104[];
int gi_108 = 5000;
int gi_112 = 5;
int gi_116 = 5;
int g_magic_120 = 110011;
int gi_124 = 3;
double gd_128 = 0.1;
int gi_136 = 0;
int gia_140[];
double gda_144[][6];
string gsa_148[];
int gia_152[];
bool gi_156 = FALSE;
int g_datetime_160 = 0;
int gi_164;
int g_datetime_168 = 0;
bool gi_172 = FALSE;

bool dllInit(int ai_0) {
   return (mtFeed00(ai_0));
}

void dllShutDown() {
   mtFeed02();
}

int dllGetMessages(int ai_0, int aia_4[10][5], double ada_8[10][2], string asa_12[10]) {
   return (mtFeed01(ai_0, aia_4, ada_8, asa_12));
}

void dllLog(string as_0) {
   mtFeed0B(as_0);
}

void dllReportCheckSymbolResult(int ai_0, int ai_4, int ai_8) {
   mtFeed03(ai_0, ai_4, ai_8);
}

void dllOnDataTransferCreated(int ai_0, int ai_4, int ai_8) {
   mtFeed04(ai_0, ai_4, ai_8);
}

void dllTransferDataChunk(int ai_0, int ai_4, double ada_8[][6], int ai_12) {
   mtFeed05(ai_0, ai_4, ada_8, ai_12);
}

void dllNotifyDataListener(int ai_0, int ai_4, double ada_8[][6]) {
   mtFeed06(ai_0, ai_4, ada_8);
}

void dllMessageProcessed(int ai_0) {
   mtFeed07(ai_0);
}

void dllOnPlacedOrder(int ai_0, int ai_4, string as_8) {
   mtFeed08(ai_0, iif(ai_4, 1, 0), as_8);
}

void dllOnOrderFilled(string as_0, double ad_8, int ai_16) {
   mtFeed09(as_0, ad_8, ai_16);
}

void dllOnCanceledOrder(int ai_0, int ai_4) {
   mtFeed0A(ai_0, iif(ai_4, 1, 0));
}

void dllCheckSubscription(int ai_0) {
   mtFeed0C(ai_0);
}

void dllSynchronizeSystemTime(int ai_0) {
   mtFeed0D(ai_0);
}

void dllGetSubscriptionInfo(int aia_0[2]) {
   mtFeed0E(aia_0);
}

int periodToTime(int ai_0) {
   return (60 * ai_0);
}

void logInfo(string as_0) {
   Print("INFO: " + as_0);
   dllLog("INFO: " + as_0);
}

void logError(string as_0, string as_8, int ai_16 = -1) {
   Print("ERROR: in " + as_0 + "()");
   dllLog("ERROR: in " + as_0 + "()");
   Print("ERROR: " + as_8);
   dllLog("ERROR: " + as_8);
   int l_error_20 = GetLastError();
   if (ai_16 != -1) l_error_20 = ai_16;
   if (l_error_20 != 0/* NO_ERROR */) {
      Print("ERROR: code=" + l_error_20 + " - " + ErrorDescription(l_error_20));
      dllLog("ERROR: code=" + l_error_20 + " - " + ErrorDescription(l_error_20));
   }
}

double iif(bool ai_0, double ad_4, double ad_12) {
   if (ai_0) return (ad_4);
   return (ad_12);
}

int orderDirection(int ai_0) {
   return (1 - ai_0 % 2 * 2);
}

string orderTypeName(int a_cmd_0 = -1) {
   if (a_cmd_0 == -1) a_cmd_0 = OrderType();
   switch (a_cmd_0) {
   case OP_SELL:
      return ("OP_SELL");
   case OP_SELLSTOP:
      return ("OP_SELLSTOP");
   case OP_SELLLIMIT:
      return ("OP_SELLLIMIT");
   case OP_BUY:
      return ("OP_BUY");
   case OP_BUYSTOP:
      return ("OP_BUYSTOP");
   case OP_BUYLIMIT:
      return ("OP_BUYLIMIT");
   }
   logError("orderTypeName", "unknown order type: " + OrderType());
   return ("");
}

void assert(string as_0, bool ai_8, string as_12 = "") {
   if (!ai_8) Print("ASSERT: in " + as_0 + "() - " + as_12);
}

double closestPossibleOpenStop(string a_symbol_0, int ai_8, double ad_12, double ad_20 = 0.0) {
   double l_point_28 = MarketInfo(a_symbol_0, MODE_POINT);
   double ld_36 = NormalizeDouble(MarketInfo(a_symbol_0, MODE_ASK) - ai_8 % 2 * MarketInfo(a_symbol_0, MODE_SPREAD) * l_point_28, MarketInfo(a_symbol_0, MODE_DIGITS));
   assert("closestPossibleOpenStop", ai_8 != 0 && ai_8 != 1, "orderType != OP_BUY && orderType != OP_SELL (orderType=" + orderTypeName(ai_8) + ")");
   int li_44 = 1;
   if (ai_8 == 5 || ai_8 == 2) li_44 = -1;
   double ld_48 = MarketInfo(a_symbol_0, MODE_STOPLEVEL) * l_point_28;
   if (ai_8 == 2 || ai_8 == 3) ld_48 += l_point_28;
   double ld_ret_56 = ld_36 + ld_48 * li_44;
   if ((ld_ret_56 - ad_12) * li_44 <= 0.0) return (ad_12);
   if (ad_20 != 0.0 && (ld_ret_56 - ad_20) * li_44 >= 0.0) return (ad_20);
   return (ld_ret_56);
}

int newDataListener(string a_symbol_0, int a_timeframe_8, int ai_12, int ai_16) {
   int li_20 = _lsAllocateInstance();
   int l_shift_24 = iBarShift(a_symbol_0, a_timeframe_8, ai_12, TRUE);
   gsa_148[li_20] = a_symbol_0;
   gda_144[li_20][0] = a_timeframe_8;
   gda_144[li_20][1] = ai_12;
   gda_144[li_20][2] = iOpen(a_symbol_0, a_timeframe_8, l_shift_24);
   gda_144[li_20][3] = iHigh(a_symbol_0, a_timeframe_8, l_shift_24);
   gda_144[li_20][4] = iLow(a_symbol_0, a_timeframe_8, l_shift_24);
   gda_144[li_20][5] = ai_16;
   return (gia_140[li_20]);
}

int _lsAllocateInstance() {
   int li_8;
   int li_0 = 1;
   if (gi_136 > 0) li_0 = gia_140[gi_136 - 1] + 1;
   int li_ret_4 = gi_136;
   gi_136++;
   if (ArrayRange(gia_140, 0) < gi_136) {
      li_8 = ArrayRange(gia_140, 0) + 128;
      ArrayResize(gia_140, li_8);
      ArrayResize(gda_144, li_8);
      ArrayResize(gsa_148, li_8);
   }
   gia_140[li_ret_4] = li_0;
   return (li_ret_4);
}

void deleteDataListener(int ai_0) {
   int li_4 = _lsIndex(ai_0);
   ArrayCopy(gia_140, gia_140, li_4, li_4 + 1, gi_136 - li_4 - 1);
   ArrayCopy(gda_144, gda_144, 6 * li_4, 6 * (li_4 + 1), 6 * (gi_136 - li_4 - 1));
   ArrayCopy(gsa_148, gsa_148, li_4, li_4 + 1, gi_136 - li_4 - 1);
   gi_136--;
}

void lsGetAllInstances(int aia_0[]) {
   ArrayResize(aia_0, gi_136);
   if (gi_136 > 0) ArrayCopy(aia_0, gia_140, 0, 0, gi_136);
}

int lsFindListenerByCookie(int ai_0) {
   for (int l_index_4 = 0; l_index_4 < gi_136; l_index_4++)
      if (_lsCookie(l_index_4) == ai_0) return (gia_140[l_index_4]);
   return (0);
}

void lsTrackDataChanges(int ai_0) {
   double l_iclose_12;
   double l_ihigh_20;
   double l_ilow_28;
   double l_point_36;
   double ld_44;
   double lda_52[][6];
   double lda_60[][6];
   int li_4 = _lsIndex(ai_0);
   int li_8 = 1;
   if (_lsPeriod(li_4) != 0) li_8 = iBarShift(_lsSymbol(li_4), _lsPeriod(li_4), _lsLastKnownBarTime(li_4)) + 1;
   if (li_8 == 1) {
      l_iclose_12 = iClose(_lsSymbol(li_4), _lsPeriod(li_4), 0);
      l_ihigh_20 = iHigh(_lsSymbol(li_4), _lsPeriod(li_4), 0);
      l_ilow_28 = iLow(_lsSymbol(li_4), _lsPeriod(li_4), 0);
      l_point_36 = MarketInfo(_lsSymbol(li_4), MODE_POINT);
      if (l_point_36 == 0.0) return;
      ld_44 = l_point_36 / 10.0;
      if (_lsLastKnownBarTime(li_4) == iTime(_lsSymbol(li_4), _lsPeriod(li_4), 0) && MathAbs(_lsLastKnownBarClose(li_4) - l_iclose_12) < ld_44 && MathAbs(_lsLastKnownBarHigh(li_4) - l_ihigh_20) < ld_44 &&
         MathAbs(_lsLastKnownBarLow(li_4) - l_ilow_28) < ld_44) return;
      _lsSetLastKnownBarClose(li_4, l_iclose_12);
      _lsSetLastKnownBarHigh(li_4, l_ihigh_20);
      _lsSetLastKnownBarLow(li_4, l_ilow_28);
   }
   ArrayCopyRates(lda_52, _lsSymbol(li_4), _lsPeriod(li_4));
   int li_56 = li_8 - 1;
   ArrayResize(lda_60, li_8);
   ArrayCopy(lda_60, lda_52, 0, 6 * (ArrayRange(lda_52, 0) - 1 - li_56), 6 * li_8);
   ArraySetAsSeries(lda_60, FALSE);
   if (_lsPeriod(li_4) == 0) lda_60[li_8 - 1][0] = MarketInfo(_lsSymbol(li_4), MODE_TIME);
   dllNotifyDataListener(_lsCookie(li_4), li_8, lda_60);
   _lsSetLastKnownBarTime(li_4, iTime(_lsSymbol(li_4), _lsPeriod(li_4), 0));
}

int _lsCookie(int ai_0) {
   return (gda_144[ai_0][5]);
}

double _lsLastKnownBarClose(int ai_0) {
   return (gda_144[ai_0][2]);
}

void _lsSetLastKnownBarClose(int ai_0, double ad_4) {
   gda_144[ai_0][2] = ad_4;
}

double _lsLastKnownBarHigh(int ai_0) {
   return (gda_144[ai_0][3]);
}

void _lsSetLastKnownBarHigh(int ai_0, double ad_4) {
   gda_144[ai_0][3] = ad_4;
}

double _lsLastKnownBarLow(int ai_0) {
   return (gda_144[ai_0][4]);
}

void _lsSetLastKnownBarLow(int ai_0, double ad_4) {
   gda_144[ai_0][4] = ad_4;
}

int _lsIndex(int ai_0) {
   int li_4;
   li_4 = ArrayBsearch(gia_140, ai_0, gi_136);
   return (li_4);
}

string _lsSymbol(int ai_0) {
   return (gsa_148[ai_0]);
}

int _lsPeriod(int ai_0) {
   return (gda_144[ai_0][0]);
}

int _lsLastKnownBarTime(int ai_0) {
   return (gda_144[ai_0][1]);
}

void _lsSetLastKnownBarTime(int ai_0, int ai_4) {
   gda_144[ai_0][1] = ai_4;
}

int newThread(int ai_0) {
   int li_4 = _thrAllocateInstance();
   gia_84[li_4][0] = ai_0;
   gia_84[li_4][2] = 1;
   return (gia_80[li_4]);
}

int _thrAllocateInstance() {
   int li_8;
   int li_0 = 1;
   if (gi_76 > 0) li_0 = gia_80[gi_76 - 1] + 1;
   int li_ret_4 = gi_76;
   gi_76++;
   if (ArrayRange(gia_80, 0) < gi_76) {
      li_8 = ArrayRange(gia_80, 0) + 128;
      ArrayResize(gia_80, li_8);
      ArrayResize(gia_84, li_8);
      ArrayResize(gsa_88, li_8);
   }
   gia_80[li_ret_4] = li_0;
   return (li_ret_4);
}

void deleteThread(int ai_0) {
   int li_4 = _thrIndex(ai_0);
   ArrayCopy(gia_80, gia_80, li_4, li_4 + 1, gi_76 - li_4 - 1);
   ArrayCopy(gia_84, gia_84, 6 * li_4, 6 * (li_4 + 1), 6 * (gi_76 - li_4 - 1));
   ArrayCopy(gsa_88, gsa_88, li_4, li_4 + 1, gi_76 - li_4 - 1);
   gi_76--;
}

void thrGetAllInstances(int aia_0[]) {
   ArrayResize(aia_0, gi_76);
   if (gi_76 > 0) ArrayCopy(aia_0, gia_80, 0, 0, gi_76);
}

bool thrFinished(int ai_0) {
   int li_4 = _thrIndex(ai_0);
   return (_thrState(li_4) == 2);
}

void thrExecuteCycle(int ai_0) {
   int li_4 = _thrIndex(ai_0);
   int li_8 = gia_84[li_4][0];
   int li_12 = li_8;
   if (li_12 == 1) _thrCSExecuteCycle(li_4);
}

int _thrMessageID(int ai_0) {
   return (gia_84[ai_0][4]);
}

int _thrState(int ai_0) {
   return (gia_84[ai_0][2]);
}

int _thrSetState(int ai_0, int ai_4) {
   gia_84[ai_0][2] = ai_4;
   return (0);
}

int _thrIndex(int ai_0) {
   int li_4;
   li_4 = ArrayBsearch(gia_80, ai_0, gi_76);
   return (li_4);
}

int newCheckSymbolThread(int ai_0, string as_4, int ai_12, int ai_16) {
   int li_ret_20 = newThread(1);
   int li_24 = _thrIndex(li_ret_20);
   gia_84[li_24][4] = ai_0;
   gia_84[li_24][1] = ai_12;
   gia_84[li_24][5] = ai_16;
   gsa_88[li_24] = as_4;
   return (li_ret_20);
}

string _thrCSSymbol(int ai_0) {
   return (gsa_88[ai_0]);
}

int _thrCSDownloadingStartTime(int ai_0) {
   return (gia_84[ai_0][3]);
}

void _thrCSSetDownloadingStartTime(int ai_0, int ai_4) {
   gia_84[ai_0][3] = ai_4;
}

void _thrCSPostResult(int ai_0, int ai_4, int ai_8 = 0) {
   dllReportCheckSymbolResult(_thrMessageID(ai_0), ai_4, ai_8);
   _thrSetState(ai_0, 2);
}

void _thrCSDoStarting(int ai_0) {
   double l_bid_4 = MarketInfo(_thrCSSymbol(ai_0), MODE_BID);
   if (l_bid_4 == 0.0 && GetLastError() == 4106/* UNKNOWN_SYMBOL */) {
      _thrCSPostResult(ai_0, 0, 0);
      return;
   }
   int li_12 = iBars(_thrCSSymbol(ai_0), _thrCSPeriod(ai_0));
   if (li_12 == 0) {
      _thrCSSetDownloadingStartTime(ai_0, TimeLocal());
      _thrSetState(ai_0, 3);
      return;
   }
   _thrCSPostResult(ai_0, 1, MathMax(iTime(_thrCSSymbol(ai_0), _thrCSPeriod(ai_0), MathMin(li_12, gi_108) - 1.0), _thrCSStartTime(ai_0)));
}

int _thrCSPeriod(int ai_0) {
   return (gia_84[ai_0][1]);
}

int _thrCSStartTime(int ai_0) {
   return (gia_84[ai_0][5]);
}

void _thrCSDoDownloading(int ai_0) {
   int li_4 = iBars(_thrCSSymbol(ai_0), _thrCSPeriod(ai_0));
   if (li_4 > 0) {
      if (iTime(_thrCSSymbol(ai_0), _thrCSPeriod(ai_0), MathMin(li_4, gi_108) - 1.0) <= _thrCSStartTime(ai_0)) {
         _thrCSPostResult(ai_0, 1, _thrCSStartTime(ai_0));
         return;
      }
   }
   if (TimeLocal() - _thrCSDownloadingStartTime(ai_0) > gi_112) {
      if (li_4 == 0) {
         _thrCSPostResult(ai_0, 0);
         return;
      }
      _thrCSPostResult(ai_0, 1, iTime(_thrCSSymbol(ai_0), _thrCSPeriod(ai_0), MathMin(li_4, gi_108) - 1.0));
      return;
   }
   double l_iopen_8 = iOpen(_thrCSSymbol(ai_0), _thrCSPeriod(ai_0), li_4 + 1024);
}

void _thrCSExecuteCycle(int ai_0) {
   switch (_thrState(ai_0)) {
   case 1:
      _thrCSDoStarting(ai_0);
      return;
   case 3:
      _thrCSDoDownloading(ai_0);
      return;
      return;
   }
}

int newDataTransfer(int ai_0, string as_4, int ai_12, int ai_16) {
   int li_20 = _dtAllocateInstance();
   gia_100[li_20][0] = ai_0;
   gia_100[li_20][1] = ai_12;
   gia_100[li_20][2] = ai_16;
   gsa_104[li_20] = as_4;
   int li_24 = iBarShift(_dtSymbol(li_20), _dtPeriod(li_20), ai_16, FALSE);
   if (ai_16 - periodToTime(_dtPeriod(li_20)) > iTime(_dtSymbol(li_20), _dtPeriod(li_20), 0)) li_24 = MathMin(iBars(_dtSymbol(li_20), _dtPeriod(li_20)), 2048) - 1.0;
   _dtSetNumBarsToTransfer(li_20, li_24 + 1 - 1);
   _dtSetStartTime(li_20, iTime(_dtSymbol(li_20), _dtPeriod(li_20), li_24));
   dllOnDataTransferCreated(ai_0, _dtMessageID(li_20), _dtNumBarsToTransfer(li_20));
   return (gia_96[li_20]);
}

int _dtAllocateInstance() {
   int li_8;
   int li_0 = 1;
   if (gi_92 > WHOLE_ARRAY) li_0 = gia_96[gi_92 - 1] + 1;
   int li_ret_4 = gi_92;
   gi_92++;
   if (ArrayRange(gia_96, 0) < gi_92) {
      li_8 = ArrayRange(gia_96, 0) + 128;
      ArrayResize(gia_96, li_8);
      ArrayResize(gia_100, li_8);
      ArrayResize(gsa_104, li_8);
   }
   gia_96[li_ret_4] = li_0;
   return (li_ret_4);
}

void deleteDataTransfer(int ai_0) {
   int li_4 = _dtIndex(ai_0);
   ArrayCopy(gia_96, gia_96, li_4, li_4 + 1, gi_92 - li_4 - 1);
   ArrayCopy(gia_100, gia_100, 5 * li_4, 5 * (li_4 + 1), 5 * (gi_92 - li_4 - 1));
   ArrayCopy(gsa_104, gsa_104, li_4, li_4 + 1, gi_92 - li_4 - 1);
   gi_92--;
}

int dtFindHavingMessageID(int ai_0) {
   for (int l_index_4 = 0; l_index_4 < gi_92; l_index_4++)
      if (_dtMessageID(l_index_4) == ai_0) return (gia_96[l_index_4]);
   return (0);
}

int dtHasMoreData(int ai_0) {
   int li_4 = _dtIndex(ai_0);
   return (_dtNumTransferredBars(li_4) < _dtNumBarsToTransfer(li_4));
}

void dtTransferNextDataChunk(int ai_0, int ai_4) {
   double lda_16[][6];
   double lda_24[][6];
   int li_8 = _dtIndex(ai_0);
   int li_12 = iBarShift(_dtSymbol(li_8), _dtPeriod(li_8), _dtStartTime(li_8), TRUE) - _dtNumTransferredBars(li_8);
   ArrayCopyRates(lda_16, _dtSymbol(li_8), _dtPeriod(li_8));
   int li_20 = MathMin(li_12, 2048);
   ArrayResize(lda_24, li_20);
   ArrayCopy(lda_24, lda_16, 0, 6 * (ArrayRange(lda_16, 0) - 1 - li_12), 6 * li_20);
   ArraySetAsSeries(lda_24, FALSE);
   dllTransferDataChunk(ai_4, _dtMessageID(li_8), lda_24, li_20);
   _dtSetNumTransferredBars(li_8, _dtNumTransferredBars(li_8) + li_20);
}

int _dtNumBarsToTransfer(int ai_0) {
   return (gia_100[ai_0][3]);
}

void _dtSetNumBarsToTransfer(int ai_0, int ai_4) {
   gia_100[ai_0][3] = ai_4;
}

int _dtNumTransferredBars(int ai_0) {
   return (gia_100[ai_0][4]);
}

void _dtSetNumTransferredBars(int ai_0, int ai_4) {
   gia_100[ai_0][4] = ai_4;
}

int _dtStartTime(int ai_0) {
   return (gia_100[ai_0][2]);
}

void _dtSetStartTime(int ai_0, int ai_4) {
   gia_100[ai_0][2] = ai_4;
}

string _dtSymbol(int ai_0) {
   return (gsa_104[ai_0]);
}

int _dtMessageID(int ai_0) {
   return (gia_100[ai_0][0]);
}

int _dtPeriod(int ai_0) {
   return (gia_100[ai_0][1]);
}

int _dtIndex(int ai_0) {
   int li_4;
   li_4 = ArrayBsearch(gia_96, ai_0, gi_92);
   return (li_4);
}

void initMessageSymbols(string &asa_0[]) {
   string ls_4 = "";
   for (int l_index_12 = 0; l_index_12 < 32; l_index_12++) ls_4 = ls_4 + " ";
   for (l_index_12 = 0; l_index_12 < ArraySize(asa_0); l_index_12++) asa_0[l_index_12] = ls_4;
}

void extractMessage(int aia_0[][], double ada_4[][], string asa_8[], int ai_12, int &aia_16[], double &ada_20[], string &as_24) {
   for (int l_index_32 = 0; l_index_32 < 5; l_index_32++) aia_16[l_index_32] = aia_0[ai_12][l_index_32];
   for (l_index_32 = 0; l_index_32 < 2; l_index_32++) ada_20[l_index_32] = ada_4[ai_12][l_index_32];
   as_24 = StringTrimRight(asa_8[ai_12]);
}

void processMessages(int ai_0, int aia_4[][], double ada_8[][], string asa_12[]) {
   int lia_20[5];
   double lda_24[2];
   string ls_28;
   int li_40;
   int li_44;
   int li_48;
   int li_52;
   int li_56;
   double ld_60;
   double ld_68;
   double ld_76;
   string ls_84;
   for (int l_count_16 = 0; l_count_16 < ai_0; l_count_16++) {
      extractMessage(aia_4, ada_8, asa_12, l_count_16, lia_20, lda_24, ls_28);
      switch (lia_20[1]) {
      case 1:
         newCheckSymbolThread(lia_20[0], ls_28, lia_20[2], lia_20[3]);
         break;
      case 2:
         newDataTransfer(lia_20[0], ls_28, lia_20[2], lia_20[3]);
         break;
      case 3:
         li_40 = dtFindHavingMessageID(lia_20[4]);
         dtTransferNextDataChunk(li_40, lia_20[0]);
         if (!dtHasMoreData(li_40)) deleteDataTransfer(li_40);
         break;
      case 4:
         li_44 = lia_20[4];
         newDataListener(ls_28, lia_20[2], lia_20[3], li_44);
         dllMessageProcessed(lia_20[0]);
         break;
      case 5:
         li_44 = lia_20[4];
         li_48 = lsFindListenerByCookie(li_44);
         deleteDataListener(li_48);
         dllMessageProcessed(lia_20[0]);
         break;
      case 6:
         gi_108 = lia_20[3];
         gi_112 = lia_20[4];
         gd_128 = lda_24[0];
         dllMessageProcessed(lia_20[0]);
         break;
      case 7:
         gi_116 = lia_20[2];
         g_magic_120 = lia_20[3];
         gi_124 = lia_20[4];
         dllMessageProcessed(lia_20[0]);
         break;
      case 8:
         li_52 = lia_20[2] >> 8;
         li_56 = lia_20[2] & 255;
         ld_60 = lia_20[3];
         ld_68 = lda_24[0];
         ld_76 = lda_24[1];
         placeOrder(lia_20[0], ls_28, li_52, li_56, ld_60, ld_68, ld_76);
         break;
      case 9:
         ls_84 = ls_28;
         cancelOrder(lia_20[0], ls_84);
      }
   }
}

void trackDataListeners() {
   int lia_0[];
   int li_8;
   lsGetAllInstances(lia_0);
   for (int l_index_4 = 0; l_index_4 < ArraySize(lia_0); l_index_4++) {
      li_8 = lia_0[l_index_4];
      lsTrackDataChanges(li_8);
   }
}

void runActiveThreads() {
   int lia_0[];
   int li_8;
   thrGetAllInstances(lia_0);
   for (int l_index_4 = 0; l_index_4 < ArraySize(lia_0); l_index_4++) {
      li_8 = lia_0[l_index_4];
      thrExecuteCycle(li_8);
      if (thrFinished(li_8)) deleteThread(li_8);
   }
}

string decodeString(string as_0) {
   string ls_ret_8 = as_0;
   for (int li_16 = 0; li_16 < StringLen(as_0); li_16++) ls_ret_8 = StringSetChar(ls_ret_8, li_16, StringGetChar(as_0, li_16) - 3);
   return (ls_ret_8);
}

void alertEncoded(string as_0) {
   Alert(decodeString(as_0));
}

void displaySubscriptionExpiredMsg() {
   alertEncoded("Sohdvh#h{whqg#|rxu#vxevfulswlrq#wr#frqwlqxh#xvlqj#wklv#surgxfw1");
   alertEncoded("\\rxu#vxevfulswlrq#wr#PWIhhg#kdv#h{sluhg1");
}

void closeLockedOrders() {
   bool l_bool_0;
   int l_ticket_8;
   int li_12;
   double l_ord_lots_16;
   string l_symbol_24;
   double l_bid_32;
   bool l_bool_44;
   while (true) {
      l_bool_0 = FALSE;
      for (int l_pos_4 = 0; l_pos_4 < OrdersTotal(); l_pos_4++) {
         OrderSelect(l_pos_4, SELECT_BY_POS);
         if (OrderMagicNumber() == g_magic_120) {
            if (OrderType() != OP_BUY && OrderType() != OP_SELL) continue;
            l_ticket_8 = OrderTicket();
            li_12 = orderDirection(OrderType());
            l_ord_lots_16 = OrderLots();
            l_symbol_24 = OrderSymbol();
            l_bid_32 = MarketInfo(OrderSymbol(), iif(li_12 > 0, 9, 10));
            for (int l_pos_40 = 0; l_pos_40 < OrdersTotal(); l_pos_40++) {
               if (l_pos_40 != l_pos_4) {
                  OrderSelect(l_pos_40, SELECT_BY_POS);
                  if (OrderMagicNumber() == g_magic_120) {
                     if (OrderType() != OP_BUY && OrderType() != OP_SELL) continue;
                     if (OrderSymbol() == l_symbol_24) {
                        if (orderDirection(OrderType()) == -li_12) {
                           l_bool_44 = OrderCloseBy(l_ticket_8, OrderTicket());
                           if (!l_bool_44) logError("closeLockedOrders", "failed to OrderCloseBy( " + l_ticket_8 + ", " + OrderTicket());
                           l_bool_0 = l_bool_44;
                        }
                     }
                  }
               }
            }
         }
      }
      if (!(l_bool_0)) break;
   }
}

string generateNSTOrderID(int ai_0) {
   return ("mtf-" + ai_0);
}

bool pendingOrderIsAlreadyKnown(int ai_0) {
   for (int l_index_4 = 0; l_index_4 < ArrayRange(gia_152, 0); l_index_4++)
      if (gia_152[l_index_4] == ai_0) return (TRUE);
   return (FALSE);
}

void removePendingOrder(int ai_0) {
   bool li_4 = FALSE;
   for (int li_8 = 0; li_8 < ArrayRange(gia_152, 0); li_8++) {
      if (gia_152[li_8] == ai_0) {
         li_4 = TRUE;
         break;
      }
   }
   assert("removePendingOrder", li_4, "found - ticket=" + ai_0);
   if (li_4) {
      if (li_8 < ArrayRange(gia_152, 0) - 1) ArrayCopy(gia_152, gia_152, li_8, li_8 + 1, ArrayRange(gia_152, 0) - li_8 - 1);
      ArrayResize(gia_152, ArrayRange(gia_152, 0) - 1);
   }
}

void findNewPendingOrders() {
   for (int l_pos_0 = 0; l_pos_0 < OrdersTotal(); l_pos_0++) {
      if (OrderSelect(l_pos_0, SELECT_BY_POS)) {
         if (OrderMagicNumber() == g_magic_120) {
            if (OrderType() == OP_BUY || OrderType() == OP_SELL) continue;
            if (pendingOrderIsAlreadyKnown(OrderTicket()) == 0) {
               ArrayResize(gia_152, ArrayRange(gia_152, 0) + 1);
               gia_152[ArrayRange(gia_152, 0) - 1] = OrderTicket();
            }
         }
      }
   }
}

double mtLotsToNSTShares(double ad_0) {
   int li_ret_8 = ad_0 / gd_128;
   return (li_ret_8);
}

double floorNumLots(string a_symbol_0, double ad_8) {
   int li_16 = ad_8 / MarketInfo(a_symbol_0, MODE_LOTSTEP);
   return (li_16 * MarketInfo(a_symbol_0, MODE_LOTSTEP));
}

double nstSharesToMTLots(string as_0, int ai_8) {
   double ld_12 = ai_8 * gd_128;
   return (floorNumLots(as_0, ld_12));
}

void checkForFilledOrders() {
   int l_ticket_8;
   findNewPendingOrders();
   bool li_0 = FALSE;
   for (int li_4 = ArrayRange(gia_152, 0) - 1; li_4 >= 0; li_4--) {
      l_ticket_8 = gia_152[li_4];
      if (OrderSelect(l_ticket_8, SELECT_BY_TICKET)) {
         if (OrderType() != OP_BUY && OrderType() != OP_SELL) continue;
         dllOnOrderFilled(generateNSTOrderID(l_ticket_8), OrderOpenPrice(), mtLotsToNSTShares(OrderLots()));
         li_0 = TRUE;
         removePendingOrder(l_ticket_8);
      }
   }
   if (li_0) closeLockedOrders();
}

int mtfOrderClose(int a_ticket_0, double a_lots_4, double a_price_12, int a_slippage_20) {
   int l_error_32;
   bool l_ord_close_24 = FALSE;
   for (int l_count_28 = 0; l_count_28 < gi_124 + 1; l_count_28++) {
      l_ord_close_24 = OrderClose(a_ticket_0, a_lots_4, a_price_12, a_slippage_20);
      if (l_ord_close_24) break;
      l_error_32 = GetLastError();
      if (l_error_32 != 146/* TRADE_CONTEXT_BUSY */ && l_error_32 != 137/* BROKER_BUSY */ && l_error_32 != 4/* SERVER_BUSY */ && l_error_32 != 6/* NO_CONNECTION */ && l_error_32 != 128/* TRADE_TIMEOUT */ &&
         l_error_32 != 130/* INVALID_STOPS */ && l_error_32 != 135/* PRICE_CHANGED */ && l_error_32 != 136/* OFF_QUOTES */ && l_error_32 != 138/* REQUOTE */) break;
      Sleep(500);
      RefreshRates();
   }
   if (!l_ord_close_24) {
      OrderSelect(a_ticket_0, SELECT_BY_TICKET);
      logInfo(OrderSymbol() + ": Bid=" + MarketInfo(OrderSymbol(), MODE_BID) + ", Ask=" + MarketInfo(OrderSymbol(), MODE_ASK));
      logError("mtfOrderClose", "failed to OrderClose( " + a_ticket_0 + ", " + a_lots_4 + ", " + a_price_12 + ", " + a_slippage_20, l_error_32);
   }
   return (l_ord_close_24);
}

int mtfOrderSend(string a_symbol_0, int a_cmd_8, double a_lots_12, double a_price_20, int a_slippage_28, double a_price_32, double a_price_40, string a_comment_48, int a_magic_56) {
   int l_error_68;
   int l_ticket_60 = 0;
   for (int l_count_64 = 0; l_count_64 < gi_124 + 1; l_count_64++) {
      l_ticket_60 = OrderSend(a_symbol_0, a_cmd_8, a_lots_12, a_price_20, a_slippage_28, a_price_32, a_price_40, a_comment_48, a_magic_56);
      if (l_ticket_60 != -1) break;
      l_error_68 = GetLastError();
      if (l_error_68 != 146/* TRADE_CONTEXT_BUSY */ && l_error_68 != 137/* BROKER_BUSY */ && l_error_68 != 4/* SERVER_BUSY */ && l_error_68 != 6/* NO_CONNECTION */ && l_error_68 != 128/* TRADE_TIMEOUT */ &&
         l_error_68 != 130/* INVALID_STOPS */ && l_error_68 != 135/* PRICE_CHANGED */ && l_error_68 != 136/* OFF_QUOTES */ && l_error_68 != 138/* REQUOTE */) break;
      Sleep(500);
      RefreshRates();
   }
   if (l_ticket_60 == -1) {
      logInfo(a_symbol_0 + ": Bid=" + MarketInfo(a_symbol_0, MODE_BID) + ", Ask=" + MarketInfo(a_symbol_0, MODE_ASK));
      logError("mtfOrderSend", "failed to OrderSend( " + a_symbol_0 + ", " + orderTypeName(a_cmd_8) + ", " + a_lots_12 + ", " + a_price_20 + ", " + a_slippage_28 + ", " +
         a_price_32 + ", " + a_price_40 + ", " + a_magic_56, l_error_68);
   }
   return (l_ticket_60);
}

void findOppositeOpenOrders(string a_symbol_0, int ai_8, double &ada_12[][]) {
   int li_20;
   for (int l_pos_16 = 0; l_pos_16 < OrdersTotal(); l_pos_16++) {
      if (OrderSelect(l_pos_16, SELECT_BY_POS)) {
         if (OrderMagicNumber() == g_magic_120) {
            if (OrderSymbol() == a_symbol_0) {
               if (OrderType() != OP_BUY && OrderType() != OP_SELL) continue;
               if (orderDirection(OrderType()) == -orderDirection(ai_8)) {
                  ArrayResize(ada_12, ArrayRange(ada_12, 0) + 1);
                  li_20 = ArrayRange(ada_12, 0) - 1;
                  ada_12[li_20][1] = OrderTicket();
                  ada_12[li_20][0] = OrderLots();
               }
            }
         }
      }
   }
}

int smartPlaceMarketOrder(string a_symbol_0, int ai_8, double ad_12, double ad_20, double &ad_28, double &ad_36) {
   double lda_52[][2];
   double ld_72;
   int li_80;
   int l_ticket_84;
   double ld_44 = ad_12;
   ArrayResize(lda_52, 0);
   findOppositeOpenOrders(a_symbol_0, ai_8, lda_52);
   if (ArrayRange(lda_52, 0) > 1) ArraySort(lda_52, ArrayRange(lda_52, 0), 0, MODE_DESCEND);
   int l_count_56 = 0;
   double ld_60 = 0;
   for (int l_index_68 = 0; l_index_68 < ArrayRange(lda_52, 0); l_index_68++) {
      OrderSelect(lda_52[l_index_68][1], SELECT_BY_TICKET);
      ld_72 = MathMin(OrderLots(), ld_44);
      li_80 = mtfOrderClose(OrderTicket(), ld_72, ad_20, gi_116);
      if (!(li_80)) break;
      ld_44 -= ld_72;
      l_count_56++;
      ld_60 += OrderClosePrice();
      if (MathAbs(ld_44) < MarketInfo(a_symbol_0, MODE_MINLOT)) break;
   }
   ad_28 = ad_12 - ld_44;
   if (MathAbs(ld_44) < MarketInfo(a_symbol_0, MODE_MINLOT)) {
      gi_164++;
      l_ticket_84 = gi_164;
   } else {
      l_ticket_84 = mtfOrderSend(a_symbol_0, ai_8, ld_44, ad_20, gi_116, 0, 0, "", g_magic_120);
      if (l_ticket_84 != -1) {
         ad_28 = ad_12;
         OrderSelect(l_ticket_84, SELECT_BY_TICKET);
         l_count_56++;
         ld_60 += OrderOpenPrice();
      }
   }
   if (l_ticket_84 != -1) ad_36 = ld_60 / l_count_56;
   return (l_ticket_84);
}

void placeOrder(int ai_0, string a_symbol_4, int ai_12, int ai_16, int ai_20, double ad_24, double ad_32) {
   int li_80;
   double l_minlot_84;
   string ls_92;
   double ld_104;
   if (ai_16 != 1) {
      dllOnPlacedOrder(ai_0, 0, 0);
      return;
   }
   int li_40 = -1;
   bool li_44 = FALSE;
   double ld_48 = 0;
   double ld_56 = 0;
   string ls_64 = "";
   int li_72 = iif(ai_12 == 1 || ai_12 == 4, 1, -1);
   bool li_76 = FALSE;
   if (li_76 == FALSE) {
      if (ai_16 > 3) logInfo("Will not place requested order because it has unsupported type: " + ai_16);
      else {
         ls_92 = ai_20 + " suffix";
         switch (ai_16) {
         case 1:
            li_80 = iif(li_72 > 0, 0, 1);
            l_minlot_84 = MarketInfo(a_symbol_4, iif(li_72 > 0, 10, 9));
            break;
         case 2:
            li_80 = iif(li_72 > 0, 4, 5);
            l_minlot_84 = closestPossibleOpenStop(a_symbol_4, li_80, ad_24);
            break;
         case 3:
            li_80 = iif(li_72 > 0, 2, 3);
            l_minlot_84 = closestPossibleOpenStop(a_symbol_4, li_80, ad_32);
         }
         l_minlot_84 = NormalizeDouble(l_minlot_84, MarketInfo(a_symbol_4, MODE_DIGITS));
         ld_104 = nstSharesToMTLots(a_symbol_4, ai_20);
         if (ai_16 != 1) li_40 = mtfOrderSend(a_symbol_4, li_80, ld_104, l_minlot_84, gi_116, 0, 0, ls_92, g_magic_120);
         else li_40 = smartPlaceMarketOrder(a_symbol_4, li_80, ld_104, l_minlot_84, ld_48, ld_56);
         if (li_40 != -1) {
            li_44 = TRUE;
            ls_64 = generateNSTOrderID(li_40);
         }
      }
   }
   dllOnPlacedOrder(ai_0, li_44, ls_64);
   if (li_44 && ai_16 == 1) {
      dllOnOrderFilled(ls_64, ld_56, mtLotsToNSTShares(ld_48));
      closeLockedOrders();
   }
}

void cancelOrder(int ai_0, string as_4) {
   bool li_16;
   int l_str2int_20;
   bool l_bool_24;
   bool li_12 = TRUE;
   if (StringSubstr(as_4, 0, StringLen("mtf-")) == "mtf-") {
      li_12 = FALSE;
      li_16 = FALSE;
      if (li_16 == FALSE) {
         l_str2int_20 = StrToInteger(StringSubstr(as_4, StringLen("mtf-")));
         l_bool_24 = OrderSelect(l_str2int_20, SELECT_BY_TICKET);
         if (!l_bool_24) logInfo("Failed to select order. ticket #" + l_str2int_20);
         else {
            if (OrderType() == OP_BUY || OrderType() == OP_SELL) logInfo("Refused to cancel order (ticket #" + l_str2int_20 + "), because it has been opened");
            else {
               if (!OrderDelete(l_str2int_20)) logError("cancelOrder", "failed to OrderDelete( " + l_str2int_20 + ")");
               else {
                  li_12 = TRUE;
                  removePendingOrder(l_str2int_20);
               }
            }
         }
      }
   }
   dllOnCanceledOrder(ai_0, li_12);
}

void checkForSubscription() {
   int lia_0[2];
   int li_4;
   int li_8;
   string ls_12;
   int l_mb_code_20;
   if (gi_172 == 0) {
      if (TimeLocal() - g_datetime_168 > 30) {
         dllGetSubscriptionInfo(lia_0);
         li_4 = lia_0[0];
         li_8 = lia_0[1];
         if (li_4 < 3) {
            if (li_4 == 0 && li_8 == 0) ls_12 = decodeString("\\rxu#vxevfulswlrq#wr#PWIhhg#iru#QhxurVkhoo#kdv#h{sluhg1");
            else ls_12 = decodeString("\\rxu#vxevfulswlrq#wr#PWIhhg#iru#QhxurVkhoo#zloo#h{sluh#lq#") + li_4 + decodeString("#gd|v#dqg#") + li_8 + decodeString("#krxuv1");
            ls_12 = ls_12 
               + "\n\n" + decodeString("Lw#lv#uhfrpphqghg#wkdw#|rx#ohw#PWIhhg#iru#QhxurVkhoo#fkhfn#" + "|rxu#vxevfulswlrq#vwdwxv#zlwk#wkh#vhuyhu#dqg#h{whqg#lw#iru#rqh#pruh#prqwk#wr#dyrlg#lqwhuuxswlrqv#l" + "q#ihhglqj#pdunhw#gdwd#dqg#h{fkdqjlqj#wudglqj#rughuv1") 
            + "\n\n" + decodeString("Zrxog#|rx#olnh#wr#rshq#wkh#dfwlydwlrq#gldorj#qrz#+wklv#zloo#uhtxluh#dq#dfwlyh#lqwhuq" + "hw#frqqhfwlrq,B");
            l_mb_code_20 = MessageBox(ls_12, decodeString("PWIhhg#iru#QhxurVkhoo"), MB_YESNO);
            if (l_mb_code_20 == IDNO) gi_172 = TRUE;
            else dllCheckSubscription(WindowHandle(Symbol(), Period()));
         }
         g_datetime_168 = TimeLocal();
      }
   }
}

int start() {
   return (0);
}

int init() {
   int lia_0[10][5];
   double lda_4[10][2];
   string lsa_8[10];
   int li_12;
   int li_16;
   gi_76 = 0;
   gi_92 = 0;
   gi_136 = 0;
   g_datetime_160 = TimeCurrent();
   gi_164 = TimeLocal();
   if (!dllInit(TimeLocal())) {
      Comment("DISABLED (another copy is already running)");
      return (0);
   }
   gi_156 = TRUE;
   Comment("Running");
   while (!IsStopped()) {
      initMessageSymbols(lsa_8);
      li_12 = dllGetMessages(10, lia_0, lda_4, lsa_8);
      if (li_12 > 0) processMessages(li_12, lia_0, lda_4, lsa_8);
      else {
         if (li_12 == 0) {
            checkForFilledOrders();
            checkForSubscription();
         } else {
            if (li_12 < 0) {
               Comment("DISABLED !!!");
               displaySubscriptionExpiredMsg();
               checkForSubscription();
               return (0);
            }
         }
      }
      runActiveThreads();
      trackDataListeners();
      Sleep(1);
      RefreshRates();
      if (TimeCurrent() != g_datetime_160) {
         li_16 = TimeLocal() - TimeCurrent();
         if (li_16 != 0) dllSynchronizeSystemTime(TimeCurrent() - TimeLocal());
         g_datetime_160 = TimeCurrent();
      }
   }
   return (1);
}

void deinit() {
   if (gi_156) dllShutDown();
}